#include "simulation.h"

#include "map.h"

Simulation::Simulation(Map *_map,std::vector<BehaviorFunction> _behaviors):
    p_map(_map)
{
    int i=0;
    for(auto behavior : _behaviors){
        glm::vec3 color;
        color[i%3]=0.5f*(1 + i/3);
        m_teams.push_back(Team(color, color, behavior));
        i++;
    }
}

void Simulation::run()
{
    for(int i=0; i<m_teams.size(); ++i){
        Team &t = m_teams[i];
        if (t.updateSpawn())
        {
            Dir randDir = Dir(rand()%4);
            Coord spawnPos = p_map->team(i) + Coord(randDir);
            t.spawn(spawnPos, *p_map);
        }
        t.updateDudes();
    }

}
