#include "team.h"

Team::Team(const glm::vec3 &teamColor, const glm::vec3 &dudeColor, BehaviorFunction _behavior):
    m_teamColor(teamColor),
    m_dudeColor(dudeColor),
    m_spawnCooldown(1),
    m_foodQuantity(NB_STARTING_FOOD),
    m_behavior(_behavior)
{
}

bool Team::updateSpawn()
{
    if(m_foodQuantity > 0)
        return !(--m_spawnCooldown);
}

void Team::spawn(Coord &d, Map &map)
{
    m_spawnCooldown = SPAWN_COOLDOWN;
    --m_foodQuantity;
    m_dudes.push_back(Dude(d, map));
}

void Team::updateDudes()
{
    for (Dude &dude : m_dudes){
        Action* action;
        m_behavior(action, dude.getMemory(), &dude);
        // TODO perform action
    }
}
